'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require('react');
var ReactDOM = require('react-dom');
var ImageLoader = require('react-imageloader');
var CircularProgress = require('material-ui/CircularProgress').default;
var omit = require('lodash/omit');
var assign = require('object-assign');

var styles = {
  wrapper: {
    width: '100%',
    height: '100%',
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'center',
    backgroundColor: 'rgb(245, 245, 245)'
  }
};

var pixelRatio = window.devicePixelRatio || 1;

var createDiv = React.createElement.bind(null, 'div');

var Image = function (_React$Component) {
  _inherits(Image, _React$Component);

  function Image() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Image);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Image.__proto__ || Object.getPrototypeOf(Image)).call.apply(_ref, [this].concat(args))), _this), _this.state = {}, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Image, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var el = ReactDOM.findDOMNode(this);
      var size = Math.max(el.offsetWidth, el.offsetHeight) * pixelRatio;
      this.setState({
        src: 'http://resizer.digital-democracy.org/' + roundUp(size) + '/' + this.props.src,
        loadStart: Date.now()
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var props = omit(this.props, ['src', 'style']);
      var _props = this.props,
          style = _props.style,
          progress = _props.progress;


      return React.createElement(ImageLoader, {
        imgProps: assign({}, props, { style: style }),
        src: this.state.src,
        style: assign({}, styles.wrapper, style),
        preloader: function preloader() {
          return progress ? React.createElement(CircularProgress, null) : React.createElement('div', null);
        },
        wrapper: function wrapper(props, element) {
          var loadTime = Date.now() - _this2.state.loadStart;
          // Only fade in if image takes more than 200ms to load
          if (element.type !== 'img' || loadTime < 200) {
            return createDiv(props, element);
          } else {
            var mergedProps = assign({}, props, {
              className: 'fadeIn'
            });
            return createDiv(mergedProps, element);
          }
        }
      });
    }
  }]);

  return Image;
}(React.Component);

module.exports = Image;

function roundUp(v) {
  return Math.ceil(v / 50) * 50;
}