'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var React = require('react');
var FlatButton = require('material-ui/FlatButton').default;

var _require = require('react-intl'),
    defineMessages = _require.defineMessages,
    FormattedMessage = _require.FormattedMessage;

var styles = {
  flatButton: {
    height: 30,
    lineHeight: '29px',
    position: 'absolute',
    right: 0,
    top: -4,
    zIndex: 3
  },
  flatButtonLabel: {
    fontSize: 12,
    top: 0
  }
};

var messages = defineMessages({
  only: {
    id: 'filter.show_only',
    defaultMessage: 'Only',
    description: 'Button text to only show a particular field value in a filter'
  }
});

var OnlyButton = function OnlyButton(props) {
  return React.createElement(FlatButton, _extends({
    labelStyle: styles.flatButtonLabel,
    label: React.createElement(FormattedMessage, messages.only),
    primary: true,
    style: styles.flatButton
  }, props));
};

module.exports = OnlyButton;