'use strict';

var _require = require('reselect'),
    createSelector = _require.createSelector;

var getFieldAnalysis = require('./field_analysis');
var getColoredField = require('./colored_field');

var CONFIG = require('../../config.json');

var getColorIndex = createSelector(getColoredField, getFieldAnalysis, function (coloredField, fieldStats) {
  var colorIndex = {};
  var values = Object.keys(fieldStats[coloredField].values);
  if (!values) return colorIndex;
  values.forEach(function (v, i) {
    colorIndex[v] = CONFIG.colors[i] || CONFIG.defaultColor;
  });
  return colorIndex;
});

module.exports = getColorIndex;