'use strict';

var _isInterestingField;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _require = require('reselect'),
    createSelector = _require.createSelector;

var getFieldAnalysis = require('./field_analysis');

var _require2 = require('../constants'),
    FIELD_TYPES = _require2.FIELD_TYPES;

var isInterestingField = (_isInterestingField = {}, _defineProperty(_isInterestingField, FIELD_TYPES.STRING, true), _defineProperty(_isInterestingField, FIELD_TYPES.BOOLEAN, true), _defineProperty(_isInterestingField, FIELD_TYPES.NUMBER, true), _defineProperty(_isInterestingField, FIELD_TYPES.DATE, true), _defineProperty(_isInterestingField, FIELD_TYPES.MIXED, true), _isInterestingField);

var getVisibleFields = createSelector(function (state) {
  return state.visibleFields && state.visibleFields.length && state.visibleFields;
}, getFieldAnalysis, function (visibleFields, fieldAnalysis) {
  if (visibleFields) return visibleFields;
  visibleFields = [];
  for (var fieldname in fieldAnalysis) {
    var fieldType = fieldAnalysis[fieldname].type;
    if (isInterestingField[fieldType]) visibleFields.push(fieldname);
  }
  return visibleFields;
});

module.exports = getVisibleFields;